/*
 * etcp.c (C) 1995 Darren Reed
 *
 * The author provides this program as-is, with no gaurantee for its
 * suitability for any specific purpose.  The author takes no responsibility
 * for the misuse/abuse of this program and provides it for the sole purpose
 * of testing packet filter policies.  This file maybe distributed freely
 * providing it is not modified and that this notice remains in tact.
 */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#ifndef	linux
#include <netinet/ip_var.h>
#include <netinet/tcpip.h>
#endif
#include "ip_compat.h"

int	scan_tcp(dev, mtu, ip, gwip, minp, maxp)
char	*dev;
int	mtu;
ip_t	*ip;
struct	in_addr	gwip;
int	minp, maxp;
{
	struct	tcphdr	*tcp;
	u_char	ipadd[4], ethadd[6];
	int	wfd, i, sport;

	tcp = (tcphdr_t *)((char *)ip + (ip->ip_hl << 2));
	printf("Scanning ports %d to %d\n", minp, maxp);
	if (!(sport = tcp->th_sport))
		sport = 128;
	wfd = initdevice((dev) ? dev : "le0", sport, 5); 
	for (i = minp; i <= maxp; i++)
	    {
		tcp->th_sport = htons(sport);
		tcp->th_dport = htons(i);
		printf("%d\r", i);
		fflush(stdout);
		switch (send_tcp(wfd, mtu, ip, gwip))
		{
		case -1 :
			perror("send_tcp");
			if (errno != EAGAIN && errno != EINTR)
				return -1;
			break;
		case -2 :
			exit(1);
		default :
		case 0 :
			readloop(wfd, i, ip->ip_src);
			break;
		}
	    }
}
